//i2c EEPROM files list
cls 2

' 色の定義
WHITE = rgb(255, 255, 255)
GREEN = rgb(0, 255, 0)
ORANGE = rgb(255, 163, 0)
DARKBLUE = rgb(0, 0, 64)

' ボタンの定義
BUTTON_UP = 5
BUTTON_DOWN = 8
BUTTON_START = 9

' ボタンリリース待ち
while !in(BUTTON_START)
wend

' 変数初期化
gp_x = 0
gp_y = 0
gp_color = WHITE

CS01 = getmptr()
mdata 0xc0,0xf0,0xfc,0xff,0xfc,0xf0,0xc0,0

i2ci 1,400
OFFSET = getmptr()
mdataw 0
BUF = getmptr()

for i=0 to 28
	mpokew OFFSET/2,i*2048
	e = i2cw(1,0x50,OFFSET,2,0)
	e = i2cr(1,0x50,BUF,32,1)
	gp_color = GREEN
	gp_lc(1,i):gp_num(i+1,2)
	if mpeekw(BUF/2) != 0x7069 then goto skip
	gp_color = WHITE
	gp_lc(4,i):gp_mem(BUF+4,8)
//	gp_num(mpeekw((BUF+14)/2),4)
//	gp_color = ORANGE
//	gp_hex(mpeekw((BUF+18)/2),4)
	gp_color = ORANGE
	gp_lc(13,i):gp_num(mpeekw((BUF+22)/2),4)
//	gp_color = ORANGE
//	gp_hex(mpeekw((BUF+26)/2),4)
	gp_color = WHITE
	gp_lc(18,i):gp_num(mpeekw((BUF+30)/2),4)
skip:
next

gprint 160,232,"Push START to Exit",ORANGE,0

' カーソル準備
i=0
sprnew(1,0,i*8,8,8,CS01,WHITE,0)
sprdsp 1,1
image_view(i)

while in(BUTTON_START)
	pre_i = i
	i = i + trig_down() - trig_up()	
	i = i + (i<0) - (i>28)	
	if i <> pre_i then sprmov 1,0,i*8:image_view(i)	
wend
end

def trig_down() {
	var ret
	ret = pre_d
	pre_d = in(BUTTON_DOWN)
	return ret & !pre_d
}
def trig_up() {
	var ret
	ret = pre_u
	pre_u = in(BUTTON_UP)
	return ret & !pre_u
}



' LCD文字表示用 便利関数
def gp_lc(x,y) {
	gp_x = x
	gp_y = y
}

' メモリー配列内の文字列を n文字分 表示
def gp_mem(a,n) {
	while n
		gprint gp_x*8,gp_y*8,chr$(mpeek(a)),gp_color
		a=a+1:gp_x=gp_x+1:n=n-1
	wend
}

' 数値を n桁分 表示
def gp_num(d,n) {
	var first
	var c
	var i
	i = n
	first = 1
	while i
		if d || first then gprint (gp_x+i-1)*8,gp_y*8,d%10,gp_color
		i = i-1:d = d/10:first = 0
	wend
	gp_x = gp_x+n
}

' 数値を16進数で n桁 表示
def gp_hex(d,n) {
	var c
	var i
	i = n
	while i
		c = d & 15
		c = c+48 + 7*(c>9)
		gprint (gp_x+i-1)*8,gp_y*8,chr$(c),gp_color
		d = d/16:i = i-1
	wend
	gp_x = gp_x+n
}

def image_view(n) {
	for y=0 to 7
		for x=0 to 7
			mpokew OFFSET/2,n*2048 + y*256 + x*32 
			e = i2cw(1,0x50,OFFSET,2,0)
			e = i2cr(1,0x50,BUF,32,1)
			sprnew(0,192+x*16,y*16,16,16,BUF,WHITE,DARKBLUE)
			sprdsp 0,1
		next
	next
}