// sin/cosを使わずに回転する
// https://srad.jp/~yasuoka/journal/624532/
// その1:スプライトの速度ベクトル

' 色定数の定義
WHITE = rgb(255, 255, 255)

' ボタンの定義
BUTTON_LEFT = 7
BUTTON_RIGHT = 6
BUTTON_START = 9

' スプライトパターン定義
IMG_CIRCLE = getmptr()
mdata 0,0x3c,0x7e,0x7e,0x7e,0x7e,0x3c,0

' 変数初期化
x=0
y=0
sx=128
sy=0

' 初期画面
cls 2

' スプライト作成・表示
sprnew(0,160+x/128,120+y/128,8,8,IMG_CIRCLE,WHITE,0)
sprdsp 0,1

' メインループ
while in(BUTTON_START)
	if !in(BUTTON_LEFT) then turn_left()
	if !in(BUTTON_RIGHT) then turn_right()
	move_circle()
	pause 8
wend
end

' 速度を左回転(約7.2°)する
def turn_left() {
	sx = sx + sy/16
	sy = sy - sx/8
	sx = sx + sy/16
}

' 速度を右回転(約7.2°)する
def turn_right() {
	sx = sx - sy/16
	sy = sy + sx/8
	sx = sx - sy/16
}

' 丸を移動する
def move_circle() {
	x=x+sx
	y=y+sy
	if x>160<<7 then x=-160<<7
	if x<-160<<7 then x=160<<7
	if y>120<<7 then y=-120<<7
	if y<-120<<7 then y=120<<7
	sprmov 0, 160+x/128, 120+y/128
}
